rabin.h
Go to the documentation of this file.
// rabin.h - originally written and placed in the public domain by Wei Dai
/// \file rabin.h
/// \brief Classes for Rabin encryption and signature schemes
#ifndef CRYPTOPP_RABIN_H
#define CRYPTOPP_RABIN_H
#include "cryptlib.h"
#include "oaep.h"
#include "pssr.h"
#include "integer.h"
NAMESPACE_BEGIN(CryptoPP)
/// \brief Rabin trapdoor function using the public key
/// \since Crypto++ 2.0
class RabinFunction : public TrapdoorFunction, public PublicKey
{
typedef RabinFunction ThisClass;
public:
/// \brief Initialize a Rabin public key
/// \param n the modulus
/// \param r element r
/// \param s element s
void Initialize(const Integer &n, const Integer &r, const Integer &s)
{m_n = n; m_r = r; m_s = s;}
void BERDecode(BufferedTransformation &bt);
void DEREncode(BufferedTransformation &bt) const;
Integer ApplyFunction(const Integer &x) const;
Integer PreimageBound() const {return m_n;}
Integer ImageBound() const {return m_n;}
bool Validate(RandomNumberGenerator &rng, unsigned int level) const;
bool GetVoidValue(const char *name, const std::type_info &valueType, void *pValue) const;
void AssignFrom(const NameValuePairs &source);
const Integer& GetModulus() const {return m_n;}
const Integer& GetQuadraticResidueModPrime1() const {return m_r;}
const Integer& GetQuadraticResidueModPrime2() const {return m_s;}
void SetModulus(const Integer &n) {m_n = n;}
void SetQuadraticResidueModPrime1(const Integer &r) {m_r = r;}
void SetQuadraticResidueModPrime2(const Integer &s) {m_s = s;}
protected:
Integer m_n, m_r, m_s;
};
/// \brief Rabin trapdoor function using the private key
/// \since Crypto++ 2.0
class InvertibleRabinFunction : public RabinFunction, public TrapdoorFunctionInverse, public PrivateKey
{
typedef InvertibleRabinFunction ThisClass;
public:
/// \brief Initialize a Rabin private key
/// \param n modulus
/// \param r element r
/// \param s element s
/// \param p first prime factor
/// \param q second prime factor
/// \param u q<sup>-1</sup> mod p
/// \details This Initialize() function overload initializes a private key from existing parameters.
void Initialize(const Integer &n, const Integer &r, const Integer &s, const Integer &p, const Integer &q, const Integer &u)
{m_n = n; m_r = r; m_s = s; m_p = p; m_q = q; m_u = u;}
/// \brief Create a Rabin private key
/// \param rng a RandomNumberGenerator derived class
/// \param keybits the size of the key, in bits
/// \details This function overload of Initialize() creates a new private key because it
/// takes a RandomNumberGenerator() as a parameter. If you have an existing keypair,
/// then use one of the other Initialize() overloads.
void Initialize(RandomNumberGenerator &rng, unsigned int keybits)
{GenerateRandomWithKeySize(rng, keybits);}
void BERDecode(BufferedTransformation &bt);
void DEREncode(BufferedTransformation &bt) const;
Integer CalculateInverse(RandomNumberGenerator &rng, const Integer &x) const;
bool Validate(RandomNumberGenerator &rng, unsigned int level) const;
bool GetVoidValue(const char *name, const std::type_info &valueType, void *pValue) const;
void AssignFrom(const NameValuePairs &source);
/*! parameters: (ModulusSize) */
void GenerateRandom(RandomNumberGenerator &rng, const NameValuePairs &alg);
const Integer& GetPrime1() const {return m_p;}
const Integer& GetPrime2() const {return m_q;}
const Integer& GetMultiplicativeInverseOfPrime2ModPrime1() const {return m_u;}
void SetPrime1(const Integer &p) {m_p = p;}
void SetPrime2(const Integer &q) {m_q = q;}
void SetMultiplicativeInverseOfPrime2ModPrime1(const Integer &u) {m_u = u;}
protected:
Integer m_p, m_q, m_u;
};
/// \brief Rabin keys
struct Rabin
{
static std::string StaticAlgorithmName() {return "Rabin-Crypto++Variant";}
typedef RabinFunction PublicKey;
typedef InvertibleRabinFunction PrivateKey;
};
/// \brief Rabin encryption scheme
/// \tparam STANDARD encryption standard
template <class STANDARD>
struct RabinES : public TF_ES<Rabin, STANDARD>
{
};
/// \brief Rabin signature scheme
/// \tparam STANDARD signature standard
/// \tparam H hash transformation
template <class STANDARD, class H>
struct RabinSS : public TF_SS<Rabin, STANDARD, H>
{
};
// More typedefs for backwards compatibility
class SHA1;
typedef RabinES<OAEP<SHA1> >::Decryptor RabinDecryptor;
typedef RabinES<OAEP<SHA1> >::Encryptor RabinEncryptor;
NAMESPACE_END
#endif
BufferedTransformation
Interface for buffered transformations.
Definition cryptlib.h:1657
GeneratableCryptoMaterial::GenerateRandomWithKeySize
void GenerateRandomWithKeySize(RandomNumberGenerator &rng, unsigned int keySize)
Generate a random key or crypto parameters.
Integer
Multiple precision integer with arithmetic operations.
Definition integer.h:50
InvertibleRabinFunction
Rabin trapdoor function using the private key.
Definition rabin.h:57
InvertibleRabinFunction::Initialize
void Initialize(const Integer &n, const Integer &r, const Integer &s, const Integer &p, const Integer &q, const Integer &u)
Initialize a Rabin private key.
Definition rabin.h:70
InvertibleRabinFunction::CalculateInverse
Integer CalculateInverse(RandomNumberGenerator &rng, const Integer &x) const
Calculates the inverse of an element.
Definition rabin.cpp:147
InvertibleRabinFunction::Initialize
void Initialize(RandomNumberGenerator &rng, unsigned int keybits)
Create a Rabin private key.
Definition rabin.h:79
InvertibleRabinFunction::GenerateRandom
void GenerateRandom(RandomNumberGenerator &rng, const NameValuePairs &alg)
Definition rabin.cpp:82
InvertibleRabinFunction::AssignFrom
void AssignFrom(const NameValuePairs &source)
Assign values to this object.
Definition rabin.cpp:232
InvertibleRabinFunction::Validate
bool Validate(RandomNumberGenerator &rng, unsigned int level) const
Check this object for errors.
Definition rabin.cpp:190
InvertibleRabinFunction::GetVoidValue
bool GetVoidValue(const char *name, const std::type_info &valueType, void *pValue) const
Get a named value.
Definition rabin.cpp:223
NameValuePairs
Interface for retrieving values given their names.
Definition cryptlib.h:327
PK_FinalTemplate
Template implementing constructors for public key algorithm classes.
Definition pubkey.h:2198
PrivateKey
Interface for private keys.
Definition cryptlib.h:2546
PublicKey
Interface for public keys.
Definition cryptlib.h:2541
RabinFunction
Rabin trapdoor function using the public key.
Definition rabin.h:19
RabinFunction::ImageBound
Integer ImageBound() const
Returns the maximum size of a representation after the trapdoor function is applied.
Definition rabin.h:36
RabinFunction::Initialize
void Initialize(const Integer &n, const Integer &r, const Integer &s)
Initialize a Rabin public key.
Definition rabin.h:28
RabinFunction::PreimageBound
Integer PreimageBound() const
Returns the maximum size of a message before the trapdoor function is applied.
Definition rabin.h:35
RandomNumberGenerator
Interface for random number generators.
Definition cryptlib.h:1440
SHA1
SHA-1 message digest.
Definition sha.h:27
TF_ES
Trapdoor Function (TF) encryption scheme.
Definition pubkey.h:2290
TF_SS
Trapdoor Function (TF) Signature Scheme.
Definition pubkey.h:2316
TrapdoorFunction
Applies the trapdoor function.
Definition pubkey.h:126
TrapdoorFunctionInverse
Applies the inverse of the trapdoor function.
Definition pubkey.h:179
cryptlib.h
Abstract base classes that provide a uniform interface to this library.
integer.h
Multiple precision integer with arithmetic operations.
CryptoPP
Crypto++ library namespace.
oaep.h
Classes for optimal asymmetric encryption padding.
pssr.h
Classes for probabilistic signature schemes.
RabinES
Rabin encryption scheme.
Definition rabin.h:117
Rabin
Rabin keys.
Definition rabin.h:107
RabinSS
Rabin signature scheme.
Definition rabin.h:125